// *********************************************
// Ajax Request handler
// *********************************************

function AjaxHandler(){}




//Request identificator string
AjaxHandler.prototype.var_ident = "No ident"




//Request timeout threshold - milliseconds
AjaxHandler.prototype.var_timeout = 120000




//Internal process poll
AjaxHandler.prototype.arr_requestPoll = new Array()

//Internal process ordinal counter
AjaxHandler.prototype.var_ordinal = 0

//Reset internal process ordinal and clear the request poll
AjaxHandler.prototype.fnc_ordinalReset = function() {
	try{
		this.arr_requestPoll = new Array()
		this.var_ordinal = 0
		this.fnc_onOrdinalReset()
	}catch(e){
		log('Error [fnc_ordinalReset]: '+e)
	}
}
AjaxHandler.prototype.fnc_onOrdinalReset = function() {
}




//Internal process counter
AjaxHandler.prototype.var_count = 0

//Increase the internal ajax process counter
AjaxHandler.prototype.fnc_countIncrease = function() {
	try{
		this.var_ordinal++
		this.var_count++
		this.fnc_onCountIncrease()
	}catch(e){
		log('Error [fnc_countIncrease]: '+e)
	}
}
AjaxHandler.prototype.fnc_onCountIncrease = function() {
}

//Decrease the internal ajax process counter
AjaxHandler.prototype.fnc_countDecrease = function() {
	try{
		this.var_count--
		this.fnc_onCountDecrease()
	}catch(e){
		log('Error [fnc_countDecrease]: '+e)
	}
}
AjaxHandler.prototype.fnc_onCountDecrease = function() {
}




AjaxHandler.prototype.fnc_init = function (args,boundaryString) {
	try{
		this.fnc_handleInitStart()

		// Output stream creation
		var outputStream = null

		outputStream = this.fnc_createStream(
			args,
			boundaryString
		)

		if(!outputStream){
			log("Error [fnc_init]: No output stream")
			return null
		}

		// XMLHttpRequest obect initialization
		var request = null

		try {
			request = new XMLHttpRequest()
			if(request.overrideMimeType){
				request.overrideMimeType('text/xml')
			}
		}catch(e){
			log("Error [fnc_init]: "+e)
		}
		if(!request){
			log("Error [fnc_init]: Fatal error! Could not create a XMLHttpRequest!")
			return null
		}

		this.fnc_handleInitEnd()

		return {
			outputStream: outputStream,
			xmlHttpRequest: request
		}
	}catch(e){
		log('Error [fnc_init]: '+e)
	}
	return null
}




//Create a new request
AjaxHandler.prototype.fnc_create = function (setup,url,args,filename)
{
	
	this.fnc_handleCreateStart()
	
	const boundaryString = new Date().getTime()
	
	var initObject = null
	
	initObject = this.fnc_init
	(
		args,
		boundaryString
	)
	
	if(initObject)
	{
		var id = this.var_ordinal
		
		var handler = this
		
		// Set Timeout
		var requestTimer = setTimeout
		(
			function()
			{
				clearTimeout(requestTimer)
				initObject.xmlHttpRequest.abort()
				handler.fnc_onTimeout(id)
			},
			handler.var_timeout
		)
		
		// Create Event Handler
		initObject.xmlHttpRequest.onreadystatechange = function(event)
		{
			// Check response
			if (initObject.xmlHttpRequest.readyState == 4)
			{
				// Clear Timeout
				clearTimeout(requestTimer)
				try
				{
					if (initObject.xmlHttpRequest.status == 200)
					{
						//alles gute
					}
				}
				catch(e)
				{
					// Error
					handler.fnc_handleError
					(
						{
							IDRequest: id,
							errorComponent: 'onreadystatechange',
							errorString: 'Could not connect - Domain or connection not available.'
						}
					)
					return
				}
				
				// All OK
				var e4x
				try
				{
					e4x = new XML
					(
						initObject.xmlHttpRequest.responseText.replace(/<\?.*\?>/gi,"")
					)
					handler.fnc_handleLoad
					(
						{
							IDRequest: id,
							e4x: e4x
						}
					)
					return
				}
				catch(e)
				{
					handler.fnc_handleError(
						{
							IDRequest: id,
							errorComponent: 'onreadystatechange',
							errorString: e
						}
					)
					return
				}
				
				// Error
				handler.fnc_handleError(
					{
						IDRequest: id,
						errorComponent: 'onreadystatechange',
						errorString: initObject.xmlHttpRequest.statusText
					}
				)
				
				return
			}
			
			return
		}
		
		try
		{
			
			this.requestUrl = url
			this.requestArguments = args
			
			// POST request always !
			if (url.length==0)
			{
				url=cs_Core.config.host+"/?"
			}
			
			//request.open("POST", url, true)
			initObject.xmlHttpRequest.open("POST", url, true, cs_Core.usrm.login, cs_Core.usrm.pass)
			var tmpUA = navigator.userAgent
			var tmpUAmatches = tmpUA.match(/^.*?Gecko\/\d+/)
			tmpUA = tmpUAmatches[0]+' Cyclone3CMS-XUL/'+ui.uipackage.getInstalledVersion()
			initObject.xmlHttpRequest.setRequestHeader(
				"User-Agent",
				tmpUA
			)
			initObject.xmlHttpRequest.setRequestHeader(
				"Content-Type",
				"multipart/form-data; charset: utf-8; boundary=---------------------------" + boundaryString
			)
			
			this.request=initObject.xmlHttpRequest
			this.arr_requestPoll[id]={
				id: id,
				setup: setup,
				url: url,
				args: args
			}
			
			this.request.send(initObject.outputStream)
			
			var returnedObject = this.fnc_handleCreateSuccess()
			this.arr_requestPoll[id].setup.timeStart=returnedObject.timeStart
			
			log("Ajax["+this.var_ident+"] Request #"+id+": TYPE="+args['type'])
			
			return true
			
		}
		catch(e)
		{
			
			alert(e)
			log('Error: Could not open or send request!')
			
			this.fnc_handleCreateFailure()
			
			return false
		}
		
	}
	else
	{
		
		log('Warning: No stream to post!')
		
		this.fnc_handleCreateFailure()
		
		return false
	}
	
}




// Reload handler
AjaxHandler.prototype.fnc_reload = function(dataObject){
	//dataObject.IDrequest
	//dataObject.setupTweak
}




// Fired at the beginning of the create function
// Useful for updating the desktop cursor, status bar, ...
AjaxHandler.prototype.fnc_handleInitStart = function(dataObject){
	var returnObject = {}

	this.fnc_onInitStart()
	
	return returnObject
}
// Fired at the end of the create function
AjaxHandler.prototype.fnc_handleInitEnd = function(dataObject){
	var returnObject = {}

	this.fnc_onInitEnd()
	
	return returnObject
}
// Fired when an ajax process is to be created
AjaxHandler.prototype.fnc_handleCreateStart = function(dataObject){
	var returnObject = {}

	this.fnc_countIncrease()
	this.fnc_onCreateStart()
	
	return returnObject
}
// Fired when an ajax process has been created
AjaxHandler.prototype.fnc_handleCreateSuccess = function(dataObject){
	var returnObject = {}

	returnObject.timeStart=new Date().getTime()
	
	return returnObject

}
// Fired when an ajax process has NOT been created
AjaxHandler.prototype.fnc_handleCreateFailure = function(dataObject){
	var returnObject = {}
	
	return returnObject

}
// Fired when an ajax process has finished loading
AjaxHandler.prototype.fnc_handleLoad = function(dataObject){
	var returnObject = {}

	this.arr_requestPoll[dataObject.IDRequest].setup.timeEnd=new Date().getTime()

	try{
		this.fnc_countDecrease()
		this.fnc_onLoad(dataObject)
	}catch(e){
		alert(e)
	}

	return returnObject
}
// Fired when an ajax process timeouts
AjaxHandler.prototype.fnc_handleTimeout = function(dataObject){
	var returnObject = {}
	
	this.arr_requestPoll[dataObject.IDRequest].setup.timeEnd=new Date().getTime()

	this.fnc_countDecrease()
	this.fnc_onTimeout()
	
	return returnObject
}
// Fired when an ajax process finishes with an error
AjaxHandler.prototype.fnc_handleError = function(dataObject){
	var returnObject = {}

	this.arr_requestPoll[dataObject.IDRequest].setup.timeEnd=new Date().getTime()

	log("Error ["+dataObject.errorComponent+"]: "+dataObject.errorString)
	this.fnc_onError(dataObject)

	return returnObject
}




// Placeholders for user-defined handling
AjaxHandler.prototype.fnc_onInitStart = function(dataObject){
}
AjaxHandler.prototype.fnc_onInitEnd = function(dataObject){
}
AjaxHandler.prototype.fnc_onCreateStart = function(dataObject){
}
AjaxHandler.prototype.fnc_onCreateSuccess = function(dataObject){
}
AjaxHandler.prototype.fnc_onCreateFailure = function(dataObject){
}
AjaxHandler.prototype.fnc_onCreate = function(dataObject){
}
AjaxHandler.prototype.fnc_onLoad = function(dataObject){
}
AjaxHandler.prototype.fnc_onTimeout =  function(dataObject){
}
AjaxHandler.prototype.fnc_onError = function(dataObject){
}




// Create a stream to post
AjaxHandler.prototype.fnc_createStream = function(postData, boundaryString){
	//create the main stream
	var nsIMultiplexInputStream = Components
	.classes["@mozilla.org/io/multiplex-input-stream;1"]
	.createInstance(Components.interfaces.nsIMultiplexInputStream)

	for (var postItem in postData){
		//log('postItem \''+postItem+'\' is of type '+typeof(postData[postItem]))

		//discontinue work if the argument is a function - we don't want to post references to server :)
		if(typeof(postData[postItem])=="function"){
			continue
		}

		//create a text stream
		var nsIStringInputStream = Components
			.classes["@mozilla.org/io/string-input-stream;1"]
			.createInstance(Components.interfaces.nsIStringInputStream)

		//log('postItem: '+typeof(postData[postItem])+' '+postData[postItem])

		//hack - if it is a file object, it does have this function, and this request won't raise an error
		if(
			(typeof(postData[postItem])=="string")
			|| (typeof(postData[postItem])=="number")
			|| (typeof(postData[postItem])=="xml")
		){
			// First, get and initialize the converter
			var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
				.createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
			converter.charset = "UTF-8"; /* The charset you want to use. Using UTF-8 in this example */
			// Now, convert a string to an nsIInputStream
			var nsIStringInputStream = converter.convertToInputStream("\r\n-----------------------------" + boundaryString + "\r\nContent-Disposition: form-data; name=\"" + postItem + "\"\r\n\r\n" + postData[postItem]);
			// stream can now be used as an nsIInputStream

			//alert("\r\n-----------------------------" + boundaryString + "\r\nContent-Disposition: form-data; name=\"" + postItem + "\"\r\n\r\n" + postData[postItem])
			//nsIStringInputStream.setData("\r\n-----------------------------" + boundaryString + "\r\nContent-Disposition: form-data; name=\"" + postItem + "\"\r\n\r\n" + postData[postItem], -1)
			nsIMultiplexInputStream.appendStream(nsIStringInputStream)
		}else if(typeof(postData[postItem])=="object"){
			if(postData[postItem].leafName){
				var aFile = Components.classes["@mozilla.org/file/local;1"].createInstance();

				if (aFile instanceof Components.interfaces.nsILocalFile){
log('INITIALIZING fil: '+postData[postItem])
log('INITIALIZING exists: '+postData[postItem].exists())
log('INITIALIZING isReadable: '+postData[postItem].isReadable())
log('INITIALIZING file: '+postData[postItem].leafName)

					// toto neviem ci bue treba vobec, ak ano, tak to treba pridat (zjavne asi moc netreba)
					//Content-Type: image\r\n
					nsIStringInputStream.setData("\r\n-----------------------------" + boundaryString + "\r\nContent-Disposition: form-data; name=\"" + postItem + "\"; filename=\"" + postData[postItem].leafName + "\"\r\n\r\n", -1)

					nsIMultiplexInputStream.appendStream(nsIStringInputStream)

					//create a binary stream
					var nsIFileInputStream = Components
						.classes["@mozilla.org/network/file-input-stream;1"]
						.createInstance(Components.interfaces.nsIFileInputStream)
					nsIFileInputStream.init(postData[postItem], 1, 1, Components.interfaces.nsIFileInputStream.CLOSE_ON_EOF)
					var nsIBufferedInputStream = Components
						.classes["@mozilla.org/network/buffered-input-stream;1"]
						.createInstance(Components.interfaces.nsIBufferedInputStream)
					nsIBufferedInputStream.init(nsIFileInputStream, 4096)

					nsIMultiplexInputStream.appendStream(nsIBufferedInputStream)
				}
			}
		}else{
log('INITIALIZING2 afile: '+postItem)
log('INITIALIZING2 afile: '+postItem.isFile())
			// toto neviem ci bue treba vobec, ak ano, tak to treba pridat (zjavne asi moc netreba)
			//Content-Type: image\r\n
			nsIStringInputStream.setData("\r\n-----------------------------" + boundaryString + "\r\nContent-Disposition: form-data; name=\"" + postItem + "\"; filename=\"" + postItem.leafName + "\"\r\n\r\n", -1)

			nsIMultiplexInputStream.appendStream(nsIStringInputStream)

			//create a binary stream
			var nsIFileInputStream = Components
				.classes["@mozilla.org/network/file-input-stream;1"]
				.createInstance(Components.interfaces.nsIFileInputStream)
			nsIFileInputStream.init(postData[postItem], 1, 1, Components.interfaces.nsIFileInputStream.CLOSE_ON_EOF)
			var nsIBufferedInputStream = Components
				.classes["@mozilla.org/network/buffered-input-stream;1"]
				.createInstance(Components.interfaces.nsIBufferedInputStream)
			nsIBufferedInputStream.init(nsIFileInputStream, 4096)

			nsIMultiplexInputStream.appendStream(nsIBufferedInputStream)
		}
	}

	var nsIStringInputStream_end = Components
		.classes["@mozilla.org/io/string-input-stream;1"]
		.createInstance(Components.interfaces.nsIStringInputStream)
	nsIStringInputStream_end.setData(
		"\r\n" + "-----------------------------" + boundaryString + "--\r\n",
		-1
	)

	nsIMultiplexInputStream.appendStream(nsIStringInputStream_end)
	return nsIMultiplexInputStream
}
