function fileDownload(str_sourcePath)
{
	try
	{
		var target = null

		/* make sure that the link is a string */
		str_sourcePath = "" + str_sourcePath + ""

		/* get a user-friendly file name from the link */
		var friendlyName = str_sourcePath.substring(str_sourcePath.lastIndexOf("/")+1)
		if(friendlyName.indexOf("?") > 0)
		{
			friendlyName = friendlyName.substring(0,friendlyName.indexOf("?"))
		}

		var prefs = Components
			.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefBranch)

		/* the default 'save to' directory */
		var tmp_filePickerDir

		if (prefs.getPrefType("browser.download.lastDir") == prefs.PREF_STRING)
		{
			/* a last download dir preference was found */
			tmp_filePickerDir = Components.classes["@mozilla.org/file/local;1"]
				.createInstance(Components.interfaces.nsILocalFile)
			tmp_filePickerDir.initWithPath(prefs.getCharPref("browser.download.lastDir"))
		}
		if(!tmp_filePickerDir.isDirectory())
		{
			/* no last download dir preference was found, getting the default temp dir */
			var tmp_tempDir = Components
				.classes['@mozilla.org/file/directory_service;1']
				.getService(Components.interfaces.nsIProperties)
				.get("TmpD", Components.interfaces.nsILocalFile)
		}

		var nsIFilePicker = Components
			.interfaces
			.nsIFilePicker

		var fp = Components
			.classes["@mozilla.org/filepicker;1"]
			.createInstance(nsIFilePicker)

		fp.defaultString = friendlyName

		fp.displayDirectory = tmp_filePickerDir
		/* set up a proper filter for the given filename */
		//fp.appendFilter("Audio Files","*.wav; *.mp3")

		fp.init(
			window,
			"",
			nsIFilePicker.modeSave
		)

		var res = fp.show()

		if (res == nsIFilePicker.returnOK){
			target = fp.file

			var persist = Components
				.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
				.createInstance(Components.interfaces.nsIWebBrowserPersist)

			var xfer =
				Components
				.classes["@mozilla.org/transfer;1"]
				.createInstance(Components.interfaces.nsITransfer)

			var io =
				Components
				.classes["@mozilla.org/network/io-service;1"]
				.getService(Components.interfaces.nsIIOService)

			var targetUri = io.newFileURI(target)
			
			var sourceUri = io.newURI(str_sourcePath, null, null)

			var dmg = Components
				.classes['@mozilla.org/download-manager;1']
				.getService(Components.interfaces.nsIDownloadManager)
				
			var r = dmg.addDownload(-1, sourceUri, targetUri, friendlyName, null, null, -1, null, persist)
			persist.progressListener = r
			
			persist.saveURI(sourceUri, null, null, null, null, target)
		} else {
			return false
		}
	}
	catch(e)
	{
		alert(e.message)
	}
}