
// *********************************************
// Ajax Request handler
// *********************************************

var AjaxPoll = new Array()
var AjaxCount = 0
var AjaxRunningCount = 0

function AjaxHandler(){}

AjaxHandler.prototype.count = 0

AjaxHandler.prototype.runningCount = 0

AjaxHandler.prototype.create = function (setup,url,args,filename) {
	const boundaryString = new Date().getTime()
	
	var outputStream = createStream(
		args,
		boundaryString
	)

	if(outputStream){
		this.count++

		this.runningCount++

		ui.window.status.set(this, 'busy')

		var id = this.count
	
		if(document.getElementById('ajaxpollcounter')){
			document.getElementById('ajaxpollcounter').value="AjaxPoll counter: "+id;
		}
	
		// XMLHttpRequest obect initialization
		var request = null
	
		try {
			request = new XMLHttpRequest()
			if(request.overrideMimeType){
				request.overrideMimeType('text/xml')
			}
		}catch(e){
			alert(e)
		}
		if (!request) return false
	
		var handler = this
		
		// Set Timeout
		var requestTimer = setTimeout(
			function() {
				clearTimeout(requestTimer)
				request.abort()
				handler.ontimeout(id)
			}, 30000
		)
	
		// Create Event Handler
		request.onreadystatechange = function(event){
			// Check response
			if (request.readyState == 4)
			{
				// Clear Timeout
				clearTimeout(requestTimer)
				if (request.status == 200) {
					// All OK
					var e4x
					try { e4x = new XML( request.responseText.replace(/<\?.*\?>/gi,"") ) } catch(e) { handler.onerror("XML RESULT :"+e) }
					handler.onload( id, e4x )
					return
				}
				// Error
				handler.onerror( id, request.statusText )
			}
			return
		}
	
		this.requestUrl = url
		this.requestArguments = args

		// POST request always !
		if (url.length==0){
			url=cs_Core.config.host+"/?"
		}

		//request.open("POST", url, true)
		request.open("POST", url, true, cs_Core.usrm.login, cs_Core.usrm.pass)
		request.setRequestHeader(
			"Content-Type",
			"multipart/form-data; charset: utf-8; boundary=---------------------------" + boundaryString
		)

		handler.onstart(id, url )

		this.request=request
		AjaxPoll[id]={id: id, setup: setup, url: url, args: args}
		
		this.request.send(outputStream)
		
		log(" XML Request #"+id+": TYPE="+args['type']+" IDapp="+args['IDapp']+" ajaxpoll length: "+AjaxPoll.length)

		return true
	}else{
		log('no stream to post!')
		return false
	}
}

// Success handler
AjaxHandler.prototype.onload = function(id,data){
	this.runningCount--
	if(this.runningCount<1){
		ui.window.status.set(this, 'ready')
	}
	//alert("SUCCESS")
}

// Timeout handler
AjaxHandler.prototype.ontimeout =  function(id){
	this.runningCount--
	if(this.runningCount<1){
		ui.window.status.set(this, 'ready')
	}
	//alert("TIMEOUT")
}

// Error handler
AjaxHandler.prototype.onerror = function(id,error){
	this.runningCount--
	if(this.runningCount<1){
		ui.window.status.set(this, 'ready')
	}
	alert("Error:"+error)
}

// Error handler
AjaxHandler.prototype.onstart = function(id,url){
}

// Reload handler
AjaxHandler.prototype.reload = function(IDrequest, setupTweak){
	
}

function createStream(postData, boundaryString){
	//create the main stream
	var nsIMultiplexInputStream = Components
	.classes["@mozilla.org/io/multiplex-input-stream;1"]
	.createInstance(Components.interfaces.nsIMultiplexInputStream)

	for (var postItem in postData){
		//log('postItem \''+postItem+'\' is of type '+typeof(postData[postItem]))
	
		//discontinue work if the argument is a function - we don't want to post references to server :)
		if(typeof(postData[postItem])=="function"){
			continue
		}
	
		//create a text stream
		var nsIStringInputStream = Components
			.classes["@mozilla.org/io/string-input-stream;1"]
			.createInstance(Components.interfaces.nsIStringInputStream)
			
		//log('postItem: '+typeof(postData[postItem])+' '+postData[postItem])
			
		//hack - if it is a file object, it does have this function, and this request won't raise an error
		if(
			(typeof(postData[postItem])=="string")
			|| (typeof(postData[postItem])=="number")
			|| (typeof(postData[postItem])=="xml")
		){
			// First, get and initialize the converter
			var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
				.createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
			converter.charset = "UTF-8"; /* The charset you want to use. Using UTF-8 in this example */
			// Now, convert a string to an nsIInputStream
			var nsIStringInputStream = converter.convertToInputStream("\r\n-----------------------------" + boundaryString + "\r\nContent-Disposition: form-data; name=\"" + postItem + "\"\r\n\r\n" + postData[postItem]);
			// stream can now be used as an nsIInputStream
			
			//alert("\r\n-----------------------------" + boundaryString + "\r\nContent-Disposition: form-data; name=\"" + postItem + "\"\r\n\r\n" + postData[postItem])
			//nsIStringInputStream.setData("\r\n-----------------------------" + boundaryString + "\r\nContent-Disposition: form-data; name=\"" + postItem + "\"\r\n\r\n" + postData[postItem], -1)
			nsIMultiplexInputStream.appendStream(nsIStringInputStream)
		}else{
			// toto neviem ci bue treba vobec, ak ano, tak to treba pridat (zjavne asi moc netreba)
			//Content-Type: image\r\n
			nsIStringInputStream.setData("\r\n-----------------------------" + boundaryString + "\r\nContent-Disposition: form-data; name=\"" + postItem + "\"; filename=\"" + postItem.leafName + "\"\r\n\r\n", -1)
			
			nsIMultiplexInputStream.appendStream(nsIStringInputStream)
			
			//create a binary stream
			var nsIFileInputStream = Components
				.classes["@mozilla.org/network/file-input-stream;1"]
				.createInstance(Components.interfaces.nsIFileInputStream)
			nsIFileInputStream.init(postData[postItem], 1, 1, Components.interfaces.nsIFileInputStream.CLOSE_ON_EOF)
			var nsIBufferedInputStream = Components
				.classes["@mozilla.org/network/buffered-input-stream;1"]
				.createInstance(Components.interfaces.nsIBufferedInputStream)
			nsIBufferedInputStream.init(nsIFileInputStream, 4096)
			
			nsIMultiplexInputStream.appendStream(nsIBufferedInputStream)
		}
	}

	var nsIStringInputStream_end = Components
		.classes["@mozilla.org/io/string-input-stream;1"]
		.createInstance(Components.interfaces.nsIStringInputStream)
	nsIStringInputStream_end.setData(
		"\r\n" + "-----------------------------" + boundaryString + "--\r\n",
		-1
	)

	nsIMultiplexInputStream.appendStream(nsIStringInputStream_end)
	return nsIMultiplexInputStream 
}
