function init(){
try{
	cs_Core.locale.get();
	
	var tmpDateObject

	var dateSet = false
	
	if(window.arguments){
		if(window.arguments[0]){
			if(window.arguments[0].initialValue && window.arguments[0].initialValue>0 ){
				tmpDateObject = cs_Toolbox.datetime.decodeTimestamp(window.arguments[0].initialValue)
				dateSet = true
			}
		}
	}
	if(!dateSet){
		var tmpDate = new Date();
		tmpDateObject = cs_Toolbox.datetime.decodeTimestamp(tmpDate.getTime()/1000)
	}
	
	setDay(tmpDateObject.j)
	setMonth(tmpDateObject.n)
	setYear(tmpDateObject.Y)

	setHour(tmpDateObject.G)
	setMinute(nozeros(tmpDateObject.i))
	setSecond(nozeros(tmpDateObject.s))
	
	setTimestamp(Math.round(tmpDateObject.timestamp))

	document.getElementById('date-picker-hours').addEventListener("ValueChange", function() { setTimestamp(dateToUnixTime()) }, false)			
	document.getElementById('date-picker-minutes').addEventListener("ValueChange", function() { setTimestamp(dateToUnixTime()) }, false)
	document.getElementById('date-picker-seconds').addEventListener("ValueChange", function() { setTimestamp(dateToUnixTime()) }, false)
	
	this.setDayBoxes()
	
}catch(e){alert(e)}
}

function confirmChoice(){
	window.opener.rofl()
	window.opener.document.ui.toolbox.anonymous.datePicker.setDateTime(
		window.arguments[0].onConfirm.containerNode,
		window.arguments[0].onConfirm.dataNode,
		window.arguments[0].onConfirm.formattedNode
	)
	window.close()
}

function getValue(valueId){
	switch (valueId){
		case "year":
			return document.getElementById('date-picker-year-value').label
		case "month":
			var tmpRows=document.getElementById('date-picker-months').getElementsByTagName('rows')
			for each(var tmpRow in tmpRows){
				var tmpBoxes=tmpRow.getElementsByTagName('box')
				
				for each(var tmpBox in tmpBoxes){
					if(tmpBox.getAttribute('class')=='active'){
						return tmpBox.getAttribute('IDitem')-1
					}
				}	
			}
		case "day":
			var tmpRows=document.getElementById('date-picker-days').getElementsByTagName('rows')
			for each(var tmpRow in tmpRows){
				var tmpBoxes=tmpRow.getElementsByTagName('box')
				
				for each(var tmpBox in tmpBoxes){
					if(tmpBox.getAttribute('class')=='active'){
						return tmpBox.getAttribute('IDitem')
					}
				}	
			}
		case "hours":
			return document.getElementById('date-picker-hours').selectedItem.value
		case "minutes":
			return document.getElementById('date-picker-minutes').selectedItem.value
		case "seconds":
			return document.getElementById('date-picker-seconds').selectedItem.value
	}
}

function setTimestamp(IDitem){
	document.getElementById('date-picker-timestamp').value=IDitem
	var tmpDateObject = cs_Toolbox.datetime.decodeTimestamp(IDitem)
	document.getElementById('date-picker-timestring').value=tmpDateObject.formattedString
}

function setSecond(IDitem){
	document.getElementById('date-picker-seconds').selectedIndex=IDitem
	setTimestamp(dateToUnixTime())
}

function setMinute(IDitem){
	document.getElementById('date-picker-minutes').selectedIndex=IDitem
	setTimestamp(dateToUnixTime())
}

function setHour(IDitem){
	document.getElementById('date-picker-hours').selectedIndex=IDitem
	setTimestamp(dateToUnixTime())
}

function setDay(IDitem){
	var tmpRows=document.getElementById('date-picker-days').getElementsByTagName('row')
	for(var i=0; i<tmpRows.length;i++){
		var tmpBoxes=tmpRows[i].getElementsByTagName('box')
		
		for(var j=0; j<tmpBoxes.length;j++){
			if(tmpBoxes[j].getAttribute('IDitem')!=IDitem){
				if(tmpBoxes[j].hasAttribute('class')){
					tmpBoxes[j].removeAttribute('class')
				}
			}else{
				tmpBoxes[j].setAttribute('class', "active")
			}
		}	
	}
	setTimestamp(dateToUnixTime())
}

function setMonth(IDitem){
	var tmpRows=document.getElementById('date-picker-months').getElementsByTagName('row')
	for(var i=0; i<tmpRows.length;i++){
		var tmpBoxes=tmpRows[i].getElementsByTagName('box')
		for(var j=0; j<tmpBoxes.length;j++){
			if(tmpBoxes[j].getAttribute('IDitem')!=IDitem){
				if(tmpBoxes[j].hasAttribute('class')){
					tmpBoxes[j].removeAttribute('class')
				}
			}else{
				tmpBoxes[j].setAttribute('class', "active")
			}
		}	
	}
	setTimestamp(dateToUnixTime())
}

function setYear(IDitem){
	document.getElementById('date-picker-year-value').setAttribute('label', IDitem)
	setTimestamp(dateToUnixTime())
}

function changeYear(mode){
	if(mode=="+"){
		document.getElementById('date-picker-year-value').setAttribute('label', Number(document.getElementById('date-picker-year-value').getAttribute('label'))+1);
	}else if(mode=="-"){
		document.getElementById('date-picker-year-value').setAttribute('label', Number(document.getElementById('date-picker-year-value').getAttribute('label'))-1);
	}
	
	if(mode=="++"){
		document.getElementById('date-picker-year-value').setAttribute('label', Number(document.getElementById('date-picker-year-value').getAttribute('label'))+10);
	}else if(mode=="--"){
		document.getElementById('date-picker-year-value').setAttribute('label', Number(document.getElementById('date-picker-year-value').getAttribute('label'))-10);
	}
	setTimestamp(dateToUnixTime())
}

function nozeros(input) {
	return input;
	if((input.length > 1) && (input.substr(0,1) == "0")) {
		return input.substr(1);
	} else {
		return input;
	}
}

function dateToUnixTime() {
	var humDate = new Date(
		getValue('year'),
		getValue('month'),
		getValue('day'),
		getValue('hours'),
		getValue('minutes'),
		getValue('seconds')
	);
	return (humDate.getTime()/1000.0)
}

function resetDayBoxes(){
try{
	var tmpBox = document.getElementById('date-picker-first-days')
	var rows = tmpBox.getElementsByTagName('row')
	var spacers = rows[1].getElementsByTagName('spacer')
	
	var currentTime = new Date(dateToUnixTime()*1000)
	
	// najskor vsetky prazdne miesta schovame
	for(var i=0; i<(spacers.length);i++){
		  spacers[i].setAttribute('hidden','true')
	}

	var tmpFirstRowLength = rows[1].getElementsByTagName('box').length

	for(i=2; i<(rows.length-1);i++){ // zaciname od druheho riadku
		var boxes = rows[i].getElementsByTagName('box')
		for(var j=0; j<(7-tmpFirstRowLength);j++){
			rows[i-1].appendChild(boxes[0]) // vzdy berieme prvy prvok a hodime ho nakoniec predchadzajuceho riadku
		}
	}
	// posledny riadok
	var boxes = rows[6].getElementsByTagName('box')
	
	// taka haluz, ze to do cyklu musim davat cez dalsiu premennu, inak to neslo 
	var tmpp = boxes.length
	for(var j=0; j<tmpp;j++){
		 rows[5].appendChild(boxes[0]) // vzdy berieme prvy prvok a hodime ho nakoniec predchadzajuceho riadku
	}
	
	for(i=5; i<7;i++){ // dame pocet dni na 31
		var boxes = rows[i].getElementsByTagName('box')
		for(var j=0; j<boxes.length;j++){
			boxes[j].setAttribute('hidden','false')
		}
	}


}catch(e){alert(e)}
}

function setDayBoxes(){

	this.resetDayBoxes()

	var currentTime = new Date(dateToUnixTime()*1000)
	// vratime sa do prveho dna v mesiaci
	var tmpFirstDayInMonth = new Date(currentTime.getTime() - (currentTime.getDate()-1)*24*60*60*1000)
	var tmpLastDayInMonth  = new Date(tmpFirstDayInMonth.getTime() + 27*24*60*60*1000)
	var lastDay
try{	
	// zistime si datum posledneho dna v mesiaci
	if(new Date(tmpLastDayInMonth.getTime()+1*24*60*60*1000).getMonth() != tmpFirstDayInMonth.getMonth())
	{
		lastDay = 28
	}
	else if(new Date(tmpLastDayInMonth.getTime()+2*24*60*60*1000).getMonth() != tmpFirstDayInMonth.getMonth())
	{
		lastDay = 29
	}
	else if(new Date(tmpLastDayInMonth.getTime()+3*24*60*60*1000).getMonth() != tmpFirstDayInMonth.getMonth())
	{
		lastDay = 30
	}
	else if(new Date(tmpLastDayInMonth.getTime()+4*24*60*60*1000).getMonth() != tmpFirstDayInMonth.getMonth())
	{
		lastDay = 31
	}
	else
	{
		alert("Error, can't count last day in the month!")
	}
	
	var tmpBox = document.getElementById('date-picker-first-days')
	
	var tmpFirstDay
	
	if(tmpFirstDayInMonth.getDay() == 0) { tmpFirstDay = 7}
	else {tmpFirstDay = tmpFirstDayInMonth.getDay()}

	var rows = tmpBox.getElementsByTagName('row')
	var spacers = rows[1].getElementsByTagName('spacer')
	
	var tmp30visible = true // pomocna premenna
	
	// ukazeme len dany pocet
	for(var i=0; i<(tmpFirstDay-1);i++){
		spacers[i].setAttribute('hidden','false')
	}
	
	for(i=1; i<(rows.length-1);i++){
		var boxes = rows[i].getElementsByTagName('box')
		if(i == (rows.length-2)){
			
			for(var k=(boxes.length-1); k>0;k--){
				if(boxes[k].getElementsByTagName('caption')[0].label > lastDay){
					if(boxes[k].getElementsByTagName('caption')[0].label == '30'){
						tmp30visible = false
					}
					boxes[k].setAttribute('hidden','true')
				}
			}
			for(k=(boxes.length-1); k>6;k--){
				var tmpBox = boxes[k]
				if(tmpBox.getAttribute('hidden')!='true' || tmp30visible == true){
					rows[i+1].insertBefore(tmpBox, rows[i+1].getElementsByTagName('box')[0])
				}
			}
		}
		else
		{
			var tmpEnd = boxes.length -tmpFirstDay
			for(var j=(boxes.length-1); j>tmpEnd;j--){ //idem odzadu				
				var tmpBox = boxes[j]
				rows[i+1].insertBefore(tmpBox, rows[i+1].getElementsByTagName('box')[0])
			}	
		}
		
	}
	window.sizeToContent()
}catch(e){alert(e)}

}


function onLoadSettings(){
	
	/*var currentTime = new Date()
	
	this.setDay(currentTime.getDate())
	this.setMonth(currentTime.getMonth()+1)
	this.setYear(currentTime.getFullYear())
	this.setMinute(currentTime.getMinutes())
	this.setSecond(currentTime.getSeconds())
	this.setHour(currentTime.getHours())*/
	


}
